#!/bin/sh
# Setup for building with Mono and gcc.  Change as needed for other
# CLR's or C compilers..

#  TickleSharp - Classes that offer Tcl/Tk binding to .NET
# 
#  Copyright (C) 2003  Scott Beasley.
# 
#  This library is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2.1 of the License, or (at your option) any later version.
#  
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#  
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
# 

cd ../src
echo "Building libraries...."
gcc -D __UNIX__ -shared -o ../bin/libtclwrapper.so tclwrapper.c -ltcl8.4 -ltk8.4
mcs -d:UNIX_SYSTEM -unsafe -t:library TickleSharp.cs -o ../bin/TickleSharp.dll

cd ../samples
echo "Building samples....."
mcs -d:UNIX_SYSTEM tcltest.cs -o ../bin/tcltest.exe -r ../bin/TickleSharp.dll
mcs -d:UNIX_SYSTEM Hello.cs -o ../bin/Hello.exe -r ../bin/TickleSharp.dll
mcs -d:UNIX_SYSTEM Scribble.cs -o ../bin/Scribble.exe -r ../bin/TickleSharp.dll
mcs -d:UNIX_SYSTEM TclSharpCalc.cs -o ../bin/TclSharpCalc.exe -r ../bin/TickleSharp.dll

cd ../build

